unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, JvHidControllerClass, ComCtrls;

type
  TPlaybackResult = (pbIgnore, pbSuccess, pbFail);

  TReport = packed record
    ReportID: Byte;
    Bytes: array [1..64] of Byte;
  end;

  mas = array [0..255] of byte;

  TMainForm = class(TForm)
    DevListBox: TListBox;
    PageControl1: TPageControl;
    LCD: TTabSheet;
    GroupBox1: TGroupBox;
    HidCtl: TJvHidDeviceController;
    VFD: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    home_str: TSpeedButton;
    end_str: TSpeedButton;
    home_all: TSpeedButton;
    end_all: TSpeedButton;
    moveXY: TSpeedButton;
    cursor_en: TSpeedButton;
    cursor_dis: TSpeedButton;
    GroupBox2: TGroupBox;
    owerwrite: TSpeedButton;
    horizontal: TSpeedButton;
    vertical: TSpeedButton;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    char_val: TEdit;
    Label5: TLabel;
    hex_val: TEdit;
    send_char: TSpeedButton;
    send_hex: TSpeedButton;
    clear_disp: TSpeedButton;
    HistoryListBox: TListBox;
    clear_log: TSpeedButton;
    InfoBtn: TSpeedButton;
    GroupBox4: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    home_str_VFD: TSpeedButton;
    end_str_VFD: TSpeedButton;
    home_all_VFD: TSpeedButton;
    end_all_VFD: TSpeedButton;
    moveXY_VFD: TSpeedButton;
    cursor_en_VFD: TSpeedButton;
    cursor_dis_VFD: TSpeedButton;
    Edit6: TEdit;
    Edit7: TEdit;
    GroupBox5: TGroupBox;
    owerwrite_VFD: TSpeedButton;
    horizontal_VFD: TSpeedButton;
    vertical_VFD: TSpeedButton;
    GroupBox6: TGroupBox;
    Label1: TLabel;
    Label8: TLabel;
    send_char_VFD: TSpeedButton;
    send_hex_VFD: TSpeedButton;
    clear_disp_VFD: TSpeedButton;
    char_val_VFD: TEdit;
    hex_val_VFD: TEdit;
    GroupBox7: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    GroupBox8: TGroupBox;
    GroupBox9: TGroupBox;
    Label11: TLabel;
    Label13: TLabel;
    font_val: TEdit;
    Label14: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    load_sym: TSpeedButton;
    get_sym: TSpeedButton;
    en_sym: TSpeedButton;
    dis_sym: TSpeedButton;
    Edit17: TEdit;
    en_EEPROM: TCheckBox;
    font_set: TSpeedButton;
    SpeedButton1: TSpeedButton;
    en_user_char: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure HidCtlDeviceChange(Sender: TObject);
    function HidCtlEnumerate(HidDev: TJvHidDevice;
      const Idx: Integer): Boolean;
    procedure HidCtlDeviceDataError(HidDev: TJvHidDevice; Error: Cardinal);
    procedure HidCtlArrival(HidDev: TJvHidDevice);
    procedure HidCtlRemoval(HidDev: TJvHidDevice);
    procedure DevListBoxClick(Sender: TObject);
    procedure InfoBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure home_strClick(Sender: TObject);
    procedure SpeedButton3Cl(Sender: TObject);
    procedure home_allClick(Sender: TObject);
    procedure end_allClick(Sender: TObject);
    procedure cursor_enClick(Sender: TObject);
    procedure cursor_disClick(Sender: TObject);
    procedure moveXYClick(Sender: TObject);
    procedure owerwriteClick(Sender: TObject);
    procedure horizontalClick(Sender: TObject);
    procedure verticalClick(Sender: TObject);
    procedure send_hexClick(Sender: TObject);
    procedure clear_dispClick(Sender: TObject);
    procedure send_charClick(Sender: TObject);
    procedure moveXY_VFDClick(Sender: TObject);
    procedure send_hex_VFDClick(Sender: TObject);
    procedure get_symClick(Sender: TObject);
    procedure load_symClick(Sender: TObject);
    procedure en_user_charClick(Sender: TObject);
    procedure dis_user_charClick(Sender: TObject);
    procedure en_symClick(Sender: TObject);
    procedure dis_symClick(Sender: TObject);
    procedure send_char_VFDClick(Sender: TObject);
    procedure font_setClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  public
    Activated: Boolean;
    Edits: array [0..63] of TEdit;
    CurrentDevice: TJvHidDevice;
    function DeviceName(HidDev: TJvHidDevice): string;
    function Apply(Line: string): TPlaybackResult;
    procedure AddToHistory(Str: string);
    procedure SetFeature(Report: TReport);
    procedure GetFeature(var Report: TReport);
  end;

const chartable_ru: mas =
(
 $00,$01,$02,$03,$04,$05,$06,$07,
 $08,$09,$0A,$0B,$0C,$0D,$0E,$0F,
 $10,$11,$12,$13,$14,$15,$16,$17,
 $18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
 $20,$21,$22,$23,$24,$25,$26,$27,
 $28,$29,$2A,$2B,$2C,$2D,$2E,$2F,
 $30,$31,$32,$33,$34,$35,$36,$37,
 $38,$39,$3A,$3B,$3C,$3D,$3E,$3F,
 $40,$41,$42,$43,$44,$45,$46,$47,
 $48,$49,$4A,$4B,$4C,$4D,$4E,$4F,
 $50,$51,$52,$53,$54,$55,$56,$57,
 $58,$59,$5A,$5B,$5C,$5D,$5E,$5F,
 $60,$61,$62,$63,$64,$65,$66,$67,
 $68,$69,$6A,$6B,$6C,$6D,$6E,$6F,
 $70,$71,$72,$73,$74,$75,$76,$77,
 $78,$79,$7A,$7B,$7C,$7D,$7E,$7F, //7f
 $80,$81,$82,$83,$84,$85,$86,$87,
 $88,$89,$8A,$8B,$8C,$8D,$8E,$8F, //8f
 $90,$91,$92,$93,$94,$95,$96,$97,
 $98,$99,$9A,$9B,$9C,$9D,$9E,$9F, //9f
 $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,
 $A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF, //af
 $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,
 $B5,$B9,$BA,$BB,$BC,$BD,$BE,$BF, //bf
 $80,$81,$82,$83,$84,$85,$86,$87,
 $88,$89,$8A,$8B,$8C,$8D,$8E,$8F, //cf
 $90,$91,$92,$93,$94,$95,$96,$97,
 $98,$99,$9A,$9B,$9C,$9D,$9E,$9F, //df
 $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,
 $A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF, //ef
 $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,
 $E8,$E9,$EE,$EB,$EC,$ED,$EE,$EF
 );

var
  MainForm: TMainForm;

implementation

uses
  Math,
  Info;

{$R *.dfm}

procedure TMainForm.FormActivate(Sender: TObject);
begin
  if not Activated then
  begin
    Activated := True;
    DevListBoxClick(Self);
    AddToHistory(' HID   ');
  end;
end;

procedure TMainForm.HidCtlDeviceChange(Sender: TObject);
var
  Dev: TJvHidDevice;
  I, N: Integer;
begin
  for I := 0 to DevListBox.Items.Count - 1 do
  begin
    Dev := TJvHidDevice(DevListBox.Items.Objects[I]);
    Dev.Free;
  end;
  DevListBox.Items.Clear;

  while HidCtl.CheckOut(Dev) do
  begin
    N := DevListBox.Items.Add(DeviceName(Dev));
    Dev.NumInputBuffers := 128;
    Dev.NumOverlappedBuffers := 128;
    DevListBox.Items.Objects[N] := Dev;
  end;
end;

function TMainForm.DeviceName(HidDev: TJvHidDevice): string;
begin
  if HidDev.ProductName <> '' then
    Result := HidDev.ProductName
  else
    Result := Format('Device VID=%.4x PID=%.4x',
      [HidDev.Attributes.VendorID, HidDev.Attributes.ProductID]);
  if HidDev.SerialNumber <> '' then
    Result := Result + Format(' (Serial=%s)', [HidDev.SerialNumber]);
end;

function TMainForm.HidCtlEnumerate(HidDev: TJvHidDevice; const Idx: Integer): Boolean;
var
  N: Integer;
  Dev: TJvHidDevice;
begin
  N := DevListBox.Items.Add(DeviceName(HidDev));
  HidCtl.CheckOutByIndex(Dev, Idx);
  Dev.NumInputBuffers := 128;
  Dev.NumOverlappedBuffers := 128;
  DevListBox.Items.Objects[N] := Dev;
  Result := True;
end;

procedure TMainForm.DevListBoxClick(Sender: TObject);
var
  I: Integer;
  Dev: TJvHidDevice;
begin
  //if Assigned(CurrentDevice) then
  //CurrentDevice := nil;
  if (DevListBox.Items.Count > 0) and (DevListBox.ItemIndex >= 0) then
  begin
    Dev := TJvHidDevice(DevListBox.Items.Objects[DevListBox.ItemIndex]);
    CurrentDevice := Dev;
    AddToHistory(' ' + DeviceName(CurrentDevice));
  end;
end;

//   
procedure TMainForm.AddToHistory(Str: string);
var
  N: Integer;
begin
  HistoryListBox.Canvas.Font := HistoryListBox.Font;
  N := HistoryListBox.Canvas.TextWidth(Str) + 16;
  if HistoryListBox.ScrollWidth < N then
    HistoryListBox.ScrollWidth := N;
  HistoryListBox.ItemIndex := HistoryListBox.Items.Add(Str);
  HistoryListBox.ClearSelection;
end;

procedure TMainForm.HidCtlDeviceDataError(HidDev: TJvHidDevice; Error: Cardinal);
begin
  AddToHistory(Format('READ ERROR: %s (%x)', [SysErrorMessage(Error), Error]));
end;

procedure TMainForm.HidCtlArrival(HidDev: TJvHidDevice);
begin
  AddToHistory(' ' + DeviceName(HidDev));
end;

procedure TMainForm.HidCtlRemoval(HidDev: TJvHidDevice);
begin
  AddToHistory(' ' + DeviceName(HidDev));
  CurrentDevice := nil;
end;

procedure TMainForm.InfoBtnClick(Sender: TObject);
begin
  if (DevListBox.Items.Count > 0) and (DevListBox.ItemIndex >= 0) then
    with TInfoForm.Create(Self) do
    begin
      Dev := TJvHidDevice(DevListBox.Items.Objects[DevListBox.ItemIndex]);
      ShowModal;
      Free;
    end;
end;

// 
procedure TMainForm.ClearBtnClick(Sender: TObject);
begin
  HistoryListBox.Items.Clear;
  HistoryListBox.ScrollWidth := 0;
end;

function TMainForm.Apply(Line: string): TPlaybackResult;
var
  I: Integer;
begin
  if Pos('WR ', Line) = 1 then
  begin
    Result := pbFail;
  end
  else
  if Pos('Selection of ', Line) = 1 then
  begin
    Result := pbFail;
    for I := 0 to DevListBox.Items.Count - 1 do
      if 'Selection of ' + DeviceName(TJvHidDevice(DevListBox.Items.Objects[I])) = Line then
      begin
        DevListBox.ItemIndex := I;
        DevListBoxClick(Self);
        Result := pbSuccess;
        Break;
      end;
  end
  else
  Result := pbIgnore;
  Application.ProcessMessages;
  Sleep(50);
  Application.ProcessMessages;
end;

//    Feature 
procedure TMainForm.SetFeature(Report: TReport);
var
  I: Integer;
  Buf: array [0..64] of Byte;  
  Str: string;
  Err: DWORD;
begin
  if Assigned(CurrentDevice) then
  begin
    Buf[0] := Report.ReportID;
    for I := 1 to CurrentDevice.Caps.FeatureReportByteLength - 1 do
    begin
      Buf[I] := Report.Bytes[I];
    end;
    if not CurrentDevice.SetFeature(Buf[0], CurrentDevice.Caps.FeatureReportByteLength) then
    begin
      Err := GetLastError;
      AddToHistory('SET FEATURE ERROR');
    end
    else
    begin
      Str := Format('WR %.2x  ', [Buf[0]]);
      for I := 1 to CurrentDevice.Caps.FeatureReportByteLength - 1 do
        Str := Str + Format('%.2x ', [Buf[I]]);
      AddToHistory(Str);
    end;
  end;
end;

//    Feature 
procedure TMainForm.GetFeature(var Report: TReport);
var
  I: Integer;
  Buf: array [0..64] of Byte;
  Str: string;
  Err: DWORD;
begin
  if Assigned(CurrentDevice) then
  begin
    Buf[0] := Report.ReportID;
    if not CurrentDevice.GetFeature(Buf[0], CurrentDevice.Caps.FeatureReportByteLength) then
    begin
      Err := GetLastError;
      AddToHistory('GET FEATURE ERROR');
    end
    else
    begin
      Str := Format('RD %.2x  ', [Buf[0]]);
      for I := 0 to CurrentDevice.Caps.FeatureReportByteLength - 2 do begin
        Str := Str + Format('%.2x ', [Buf[I+1]]);
        Report.Bytes[I+1]:=Buf[I];
      end;  
      AddToHistory(Str);
    end;
  end;
end;

//     
procedure TMainForm.home_strClick(Sender: TObject);
var
  Report: TReport;
begin
  FillChar(Report.Bytes, 63, #0);
  //   5,     
  Report.ReportID:=5;
  GetFeature(Report);
  //    ()   0
  Report.Bytes[1]:=0;
  //   
  SetFeature(Report);
end;

//     
procedure TMainForm.SpeedButton3Cl(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=5;
  //   5,     
  GetFeature(Report);
  //    ()   19
  Report.Bytes[1]:=19;
  //   
  SetFeature(Report);
end;

//     
procedure TMainForm.home_allClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=5;
  //   5,      
  GetFeature(Report);
  //   
  Report.Bytes[1]:=0;
  Report.Bytes[2]:=0;
  //  
  SetFeature(Report);
end;

//     
procedure TMainForm.end_allClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=5;
  //  5,      
  GetFeature(Report);
  //   
  Report.Bytes[1]:=19;
  Report.Bytes[2]:=1;
  //  
  SetFeature(Report);
end;

// 
procedure TMainForm.cursor_enClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=5;
  //  5
  GetFeature(Report);
  Report.Bytes[5]:=1;
  //     
  SetFeature(Report);
end;

// 
procedure TMainForm.cursor_disClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=5;
  //  5
  GetFeature(Report);
  Report.Bytes[5]:=0;
  //     
  SetFeature(Report);
end;

// 
procedure TMainForm.moveXYClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=5;
  //  5
  GetFeature(Report);
  Report.Bytes[1]:=StrToInt(Edit2.Text);
  Report.Bytes[2]:=StrToInt(Edit3.Text);
  //     
  SetFeature(Report);
end;

//     
procedure TMainForm.owerwriteClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=2;
  Report.Bytes[2]:=0;
  Report.Bytes[3]:=0;
  SetFeature(Report);
end;

//      
procedure TMainForm.horizontalClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=2;
  Report.Bytes[2]:=0;
  Report.Bytes[3]:=1;
  SetFeature(Report);
end;

//      
procedure TMainForm.verticalClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=2;
  Report.Bytes[2]:=1;
  Report.Bytes[3]:=0;
  SetFeature(Report);
end;

//     
procedure TMainForm.send_hexClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=3;
  Report.Bytes[1]:=StrToIntDef('$' + hex_val.Text, 0);
  SetFeature(Report);
end;

//  
procedure TMainForm.clear_dispClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=2;
  GetFeature(Report);
  Report.Bytes[1]:=1;
  SetFeature(Report);
end;

//    
procedure TMainForm.send_charClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=3;
  Report.Bytes[1]:=chartable_ru[ord(char_Val.Text[1])];
  //Report.Bytes[1]:=ord(char_val.Text[1]);
  SetFeature(Report);
end;

// 
procedure TMainForm.moveXY_VFDClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=5;
  GetFeature(Report);
  Report.Bytes[1]:=StrToInt(Edit6.Text);
  Report.Bytes[2]:=StrToInt(Edit7.Text);
  SetFeature(Report);
end;

//     
procedure TMainForm.send_hex_VFDClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=3;
  Report.Bytes[1]:=StrToIntDef('$' + hex_val_VFD.Text, 0);
  SetFeature(Report);
end;

//    
procedure TMainForm.get_symClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=6;
  Report.Bytes[1]:=StrToIntDef('$' + font_val.Text, 0);
  
  Report.Bytes[11]:=32;//(1<<5) 
  SetFeature(Report);
  GetFeature(Report);
  Edit11.Text:=IntToHex(Report.Bytes[2], 0);
  Edit12.Text:=IntToHex(Report.Bytes[3], 0);
  Edit13.Text:=IntToHex(Report.Bytes[4], 0);
  Edit14.Text:=IntToHex(Report.Bytes[5], 0);
  Edit15.Text:=IntToHex(Report.Bytes[6], 0);
  Edit16.Text:=IntToHex(Report.Bytes[7], 0);
  Edit17.Text:=IntToHex(Report.Bytes[8], 0);
end;

//     (User chars)
procedure TMainForm.load_symClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=6;
  Report.Bytes[1]:=StrToIntDef('$' + font_val.Text, 0);
  Report.Bytes[2]:=StrToIntDef('$' + Edit11.Text, 0);
  Report.Bytes[3]:=StrToIntDef('$' + Edit12.Text, 0);
  Report.Bytes[4]:=StrToIntDef('$' + Edit13.Text, 0);
  Report.Bytes[5]:=StrToIntDef('$' + Edit14.Text, 0);
  Report.Bytes[6]:=StrToIntDef('$' + Edit15.Text, 0);
  Report.Bytes[7]:=StrToIntDef('$' + Edit16.Text, 0);
  Report.Bytes[8]:=StrToIntDef('$' + Edit17.Text, 0);
  Report.Bytes[9]:=5;
  Report.Bytes[10]:=7;
  Report.Bytes[11]:=1;// 
  SetFeature(Report);
end;

//      
//user chars
procedure TMainForm.en_user_charClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=6;
  Report.Bytes[11]:=2;//(1<<1)  
  SetFeature(Report);
end;

//      
//user chars
procedure TMainForm.dis_user_charClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=6;
  Report.Bytes[11]:=4;//(1<<2)  
  SetFeature(Report);
end;

//     
//user chars
procedure TMainForm.en_symClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=6;
  Report.Bytes[1]:=StrToIntDef('$' + font_val.Text, 0);

  Report.Bytes[11]:=16;//(1<<4)  
  SetFeature(Report);
end;

//     
//user chars
procedure TMainForm.dis_symClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=6;
  Report.Bytes[1]:=StrToIntDef('$' + font_val.Text, 0);

  Report.Bytes[11]:=8;//(1<<3)  
  SetFeature(Report);
end;

//    
procedure TMainForm.send_char_VFDClick(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=3;
  //     
  //   
  Report.Bytes[1]:=chartable_ru[ord(char_Val_VFD.Text[1])];
  SetFeature(Report);
end;

//   
procedure TMainForm.font_setClick(Sender: TObject);
var
  Report: TReport;
  lo, hi: byte;
begin
  Report.ReportID:=1;
  lo:=ComboBox1.ItemIndex;
  hi:=ComboBox2.ItemIndex;
  Report.Bytes[1]:=hi*16+lo;
  if en_EEPROM.Checked
    then Report.Bytes[1]:=Report.Bytes[1]+128;
  If (ComboBox1.ItemIndex<>-1) and (ComboBox2.ItemIndex<>-1)
    then SetFeature(Report)
    else AddToHistory('  ');
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
var
  Report: TReport;
begin
  Report.ReportID:=6;
  if en_user_char.Checked
    then Report.Bytes[11]:=2//(1<<1)  
    else Report.Bytes[11]:=4;//(1<<2)  
  SetFeature(Report);
end;

end.
